package de.lmu.ifi.pms.cep.dura.compiler.dura.desugaring;

import java.util.LinkedList;
import java.util.Queue;

import org.antlr.runtime.CommonToken;
import org.antlr.runtime.tree.CommonTree;

import de.lmu.ifi.pms.cep.dura.compiler.antlr.DuraParser;


public class AnonymousQueryIdentifiers extends Transformation {

	@Override
	public void apply(CommonTree tree) {
		for (CommonTree eventSpecification : collectEventSpecificationNodes(tree)) {
			boolean named = false;
			String temp = null;
			if (EMIT_ANNOTATIONS) {
				temp = eventSpecification.toStringTree();
			}
			
			
			Queue<CommonTree> nodeQueue = new LinkedList<CommonTree>();
			nodeQueue.add(eventSpecification);
			
			while(!nodeQueue.isEmpty()) {
				CommonTree node = (CommonTree) nodeQueue.remove();			
					
				if (node.getType() == DuraParser.EVENT_QUERY || node.getType() == DuraParser.EVENT_QUERY) {
					CommonTree identifier = (CommonTree) node.getChild(0);
					
					if (identifier.getChildCount() == 0) {
						identifier.addChild(new CommonTree(new CommonToken(DuraParser.ID, createName())));
						
						named = true;
					}
				}
					
				if (node.getChildCount() > 0) {
					for (Object c : node.getChildren()) {
						CommonTree child = (CommonTree) c;
						
						if (child.getType() != DuraParser.SUPPLEMENT) {
							nodeQueue.add(child);
						}
					}
				}
			}
			
			resetNextNameId();
			
			if (EMIT_ANNOTATIONS) {
				if (named) {
					CommonTree annotation = new CommonTree(new CommonToken(DuraParser.ANNOTATION, "ANNOTATION"));
					annotation.addChild(new CommonTree(new CommonToken(DuraParser.STRING, "\"Result of transformation " + this.getClass().getSimpleName() + ".\"")));
					annotation.addChild(new CommonTree(new CommonToken(DuraParser.STRING, "\"Named anonymous identifier in deductive rule " + temp + ".\"")));
					eventSpecification.getParent().addChild(annotation);
				}
			}
		}
	}

}
