package de.lmu.ifi.pms.cep.dura.compiler.durac.formula_transformations;

import de.lmu.ifi.pms.cep.dura.compiler.durac.collections.UnambiguousQueryVariables;
import de.lmu.ifi.pms.cep.dura.compiler.exceptions.DuraCExceptionWrapper;
import de.lmu.ifi.pms.cep.dura.compiler.exceptions.DuraUnknownVariableException;
import de.lmu.ifi.pms.cep.tsa.conditions.AtomicTerm;
import de.lmu.ifi.pms.cep.tsa.conditions.Term;
import de.lmu.ifi.pms.cep.tsa.conditions.Variable;
import de.lmu.ifi.pms.java.util.adaption.Adapter;

class MapReplaceVariables  implements Adapter<AtomicTerm<?>, Term<?>> {
	public final UnambiguousQueryVariables variables;
	
	public MapReplaceVariables(UnambiguousQueryVariables variables) {
		
		this.variables = variables;
	}

	@Override
	public Term<?> adapt(AtomicTerm<?> source) {
		if (source instanceof Variable) {
			try {
				return variables.getVariableAttribute((Variable<?>) source);
			} catch (DuraUnknownVariableException e) {
				throw new DuraCExceptionWrapper(e);
			}
		} else {
			return source;
		}
	}
}
