package de.lmu.ifi.pms.cep.dura.compiler.durac.formula_transformations;

import java.util.Map;

import de.lmu.ifi.pms.cep.tsa.TSA_SyntaxPatterns;
import de.lmu.ifi.pms.cep.tsa.conditions.AtomicTerm;
import de.lmu.ifi.pms.cep.tsa.conditions.Attribute;
import de.lmu.ifi.pms.java.util.adaption.Adapter;


class MapSubstituteAttributePrefix implements Adapter<AtomicTerm<?>, AtomicTerm<?>> {

	private final Map<String, String> prefix;
	
	public MapSubstituteAttributePrefix(Map<String, String> prefix) {
		this.prefix = prefix;
	}
	
	@Override
	public AtomicTerm<?> adapt(AtomicTerm<?> source) {
		if (source instanceof Attribute) {
			Attribute<?> attribute = (Attribute<?>) source;
			
			String[] components = TSA_SyntaxPatterns.splitAttributeName(attribute.name);

			if (prefix.containsKey(components[0])) {
				components[0] = prefix.get(components[0]);
				
				return attribute.rename(TSA_SyntaxPatterns.attributeName(components));
			}
		}
		
		return source;
	}
}
