package de.lmu.ifi.pms.cep.dura.compiler.durac.token_mappings;

import de.lmu.ifi.pms.cep.tsa.schema.BasicType;
import de.lmu.ifi.pms.cep.tsa.schema.BasicTypeID;
import de.lmu.ifi.pms.java.util.map.fixed.FixedArrayNavigableMap;
import static de.lmu.ifi.pms.cep.tsa.schema.BasicTypeID.*;

public class DuraBasicTypesMapping {
	private static final FixedArrayNavigableMap<String, BasicTypeID> fromDuraMap = new FixedArrayNavigableMap<String, BasicTypeID>(
			new      String[]{"timestamp", "duration", "boolean", "int", "long", "float", "double", "string", "identifier", "reference"}, 
			new BasicTypeID[]{  TIMESTAMP,   DURATION,   BOOLEAN,   INT,   LONG,   FLOAT,   DOUBLE,   STRING,   IDENTIFIER,   REFERENCE}
	);
	
	public static BasicTypeID fromDuraName(final String duraTypeName) {
		return fromDuraMap.get(duraTypeName);
	}
	
	public static boolean compatible(BasicType t1, BasicType t2) {
		if (isNumber(t1) && isNumber(t2)) {
			return t1.compareTo(t2) <= 0;
		} else {
			return t1.compareTo(t2) == 0;
		}
	}
	
	public static boolean isNumber(BasicType t) {
		switch (t.ID) {
		case INT:
		case LONG:
		case FLOAT:
		case DOUBLE:
			return true;

		default:
			return false;
		}
	}
}
