package de.lmu.ifi.pms.cep.event_mill.configuration;

import java.sql.Driver;
import java.sql.SQLException;

/**
 * Provides access to Class.getClassLoader and DriverManager
 *   for classes loaded by a different ClassLoader.
 */
public abstract class DriverReader {
    /**
     * Returns {@code DriverManager.getDrivers()}.
     */
    public abstract java.util.Enumeration<Driver> getDrivers();
    /**
     * Returns {@code DriverManager.deregisterDriver(driver)}.
     */
    public abstract void deregisterDriver(final Driver driver) throws SQLException;
    
    public DriverReader() {
		
	}
    
}