package de.lmu.ifi.pms.cep.event_mill.configuration;

import java.sql.Driver;
import java.sql.DriverManager;
import java.sql.SQLException;

/**
 * Provides access to Class.getClassLoader and DriverManager
 *   for classes loaded by a different ClassLoader.
 */
public class DriverReaderImpl extends DriverReader{
    /**
     * Returns {@code DriverManager.getDrivers()}.
     */
    @Override
	public java.util.Enumeration<Driver> getDrivers() {
        return DriverManager.getDrivers();
    }
    /**
     * Returns {@code DriverManager.deregisterDriver(driver)}.
     */
    @Override
	public void deregisterDriver(final Driver driver) throws SQLException {
        DriverManager.deregisterDriver(driver);
    }
    
    public DriverReaderImpl() {
		super();
	}
    
}