package de.lmu.ifi.pms.cep.event_mill.configuration;

import java.io.File;
import java.io.FileFilter;
import java.net.MalformedURLException;
import java.net.URL;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.lmu.ifi.pms.java.LoggingObject;

public final class LiberiesLoader extends LoggingObject{
	
	public static final Logger logger = LoggerFactory.getLogger(LiberiesLoader.class);
	
	public static String libPath = DEFAULTS.resourceFilePath("lib/", LiberiesLoader.class);
	public static String mainPath = DEFAULTS.resourceFilePath("/", LiberiesLoader.class);
	
	public static URL[] URLs(){
		File libaryFolder = new File(libPath);
		File mainFolder = new File(mainPath);
		assert libaryFolder.isDirectory() | !libaryFolder.exists();
		assert mainFolder.isDirectory() | !mainFolder.exists();
	
		FileFilter filter = new FileFilter() {
			
			@Override
			public boolean accept(final File pathname) {
				if(pathname.isFile()){
					if(pathname.getName().endsWith(".jar")){
						return true;
					}
				}
				return false;
			}
		};
		File[] libFiles1 = libaryFolder.listFiles(filter);
		if(libFiles1 == null){
			libFiles1 = new File[0];
		}
		File[] libFiles2 = mainFolder.listFiles(filter);
		if(libFiles2 == null){
			libFiles2 = new File[0];
		}
		
		java.util.ArrayList<URL> urls = new java.util.ArrayList<URL>(libFiles1.length + libFiles2.length);
		
		for(int index1 = 0; index1 < libFiles1.length; ++index1){
			try {
				urls.add(libFiles1[index1].toURI().toURL());
			} catch (MalformedURLException e) {
				logger.warn("",e);
			}
		}
		
		for(int index2 = 0; index2 < libFiles2.length; ++index2){
			try {
				urls.add(libFiles2[index2].toURI().toURL());
			} catch (MalformedURLException e) {
				logger.warn("",e);
			}
		}
		
		return urls.toArray(new URL[urls.size()]);
	}
	
	public static ExtendibleURLClassLoader classLoader(){
		return new ExtendibleURLClassLoader(URLs(), LiberiesLoader.class.getClassLoader());
	}
	
	public static final ExtendibleURLClassLoader classLoader = classLoader();	

	private LiberiesLoader(){
		
	}
	
	@Override
	protected Logger logger() {
		return logger;
	}
	
	public static void main(final String[] args) {
		System.out.println("hello");
	}
	
}
