package de.lmu.ifi.pms.cep.event_mill.io;

import java.lang.reflect.Array;
import java.util.Arrays;

import de.lmu.ifi.pms.java.util.collection.Collection;
import de.lmu.ifi.pms.java.util.tupel.Single;


public abstract class MessageSink<MessageType>{
	
	public final Class<MessageType> type;
	
	public MessageSink(final Class<MessageType> type){
		this.type = type;
	}
	
	@SuppressWarnings("unchecked")
	public final MessageType[] newBlock(final int size){
		return (MessageType[])Array.newInstance(this.type, size);
	}
	
	public void write(final MessageType message){
		this.writeBlock(new Single<MessageType, MessageType>(message));
	}
	
	public void writeBlock(final MessageType[] messages){
		this.writeBlock(Arrays.asList(messages));
	}
	
	public abstract void writeBlock(final java.util.Collection<MessageType> messages);
	
	public void writeBlock(final Collection<MessageType> messages){
		this.writeBlock(messages.javaCollection());
	}
	
	public void close() {

	}
	
	@Override
	protected void finalize() throws Throwable {
		this.close();
	}
	
}
