package de.lmu.ifi.pms.cep.event_mill.io.stream;

import org.slf4j.Logger;

import de.lmu.ifi.pms.cep.event_mill.io.format.MessageFormatProvider;
import de.lmu.ifi.pms.cep.tsa.schema.BasicTypeID;
import de.lmu.ifi.pms.java.util.collection.array.fixed.FixedArray;
import de.lmu.ifi.pms.java.util.map.fixed.FixedArrayNavigableMap;


public abstract class SinkStream extends Stream{
	
	public SinkStream(final String name, final FixedArrayNavigableMap<String, BasicTypeID> types){
		super(name, types);
	}
	
	public SinkStream(final String name, final FixedArray<String> parameters, final FixedArray<BasicTypeID> types) {
		super(name, parameters, types);
	}
	
	public <MessageType> StreamMessageSink<MessageType> format(final MessageFormatProvider<MessageType> formatProvider){
		return new StreamMessageSink<MessageType>(this, formatProvider);
	}
	
	public abstract boolean nextBlock();
	
	public abstract boolean next();
	
	
	public abstract void setString(final int parameterIndex, String value);

	
	public abstract void setBoolean(final int parameterIndex, boolean value);

	
	public abstract void setByte(final int parameterIndex, byte value);

	
	public abstract void setShort(final int parameterIndex, short value);

	
	public abstract void setInt(final int parameterIndex, int value);

	
	public abstract void setLong(final int parameterIndex, long value);
	
	public abstract void setTimestamp(final int parameterIndex, long value);
	
	public abstract void setDuration(final int parameterIndex, long value);
	
	public abstract void setIdentifier(final int parameterIndex, long value);

	
	public abstract void setFloat(final int parameterIndex, float value);

	
	public abstract void setDouble(final int parameterIndex, double value);

	
	public void setString(final String columnLabel, final String value) {
		this.setString(this.findColumn(columnLabel), value);
	}

	
	public void setBoolean(final String columnLabel, final boolean value) {
		this.setBoolean(this.findColumn(columnLabel), value);
	}

	
	public void setByte(final String columnLabel, final byte value) {
		this.setByte(this.findColumn(columnLabel), value);
	}

	
	public void setShort(final String columnLabel, final short value) {
		this.setShort(this.findColumn(columnLabel), value);
	}

	
	public void setInt(final String columnLabel, final int value) {
		this.setInt(this.findColumn(columnLabel), value);
	}

	
	public void setLong(final String columnLabel, final long value) {
		this.setLong(this.findColumn(columnLabel), value);
	}
	
	public void setTimestamp(final String columnLabel, final long value) {
		this.setLong(this.findColumn(columnLabel), value);
	}
	
	public void setDuration(final String columnLabel, final long value) {
		this.setLong(this.findColumn(columnLabel), value);
	}
	
	public void setIdentifier(final String columnLabel, final long value) {
		this.setLong(this.findColumn(columnLabel), value);
	}

	public void setFloat(final String columnLabel, final float value) {
		this.setFloat(this.findColumn(columnLabel), value);
	}

	public void setDouble(final String columnLabel, final double value) {
		this.setDouble(this.findColumn(columnLabel), value);
	}

	
//	public boolean isFirst() {
//
//	}
//
//	
//	public boolean isLast() {
//
//	}

	
//	public void setFetchSize(final int rows) {
//
//	}
//
//	
//	public int getFetchSize() {
//
//	}
	
	@Override
	protected abstract Logger logger();

}