package de.lmu.ifi.pms.cep.event_mill.sql;

import java.sql.SQLException;

public class SQL_EXCEPTIONS {
	
	public static boolean isRollback(final SQLException e){
		//FIXME assert e.getSQLState() != null : "SQLState of SQLException is null: \n" + e.getStackTrace();
		if(e.getSQLState() != null){
			return e.getSQLState().startsWith("40");
		}
		else if(e.getMessage() != null){
			return e.getMessage().contains("ROLLBACK");
		}
		else{
			return false;
		}
	}
	
	public static boolean isConnectionFailure(final SQLException e){
		//FIXME assert e.getSQLState() != null : "SQLState of SQLException is null: \n" + e.getStackTrace();
		if(e.getSQLState() != null){
			return e.getSQLState().startsWith("80");
		}
		else if(e.getMessage() != null){
			return e.getMessage().contains("mserver still alive?");
		}
		else{
			return false;
		}
	}
	
	public static boolean isPreparedStatementUnknownHandleFailure(final SQLException e){
		//FIXME assert e.getSQLState() != null : "SQLState of SQLException is null: \n" + e.getStackTrace();
		if(e.getSQLState() != null){
			return e.getSQLState().startsWith("26");
		}
		else if(e.getMessage() != null){			
			if(e.getMessage().contains("EXEC: no prepared statement with id:")){
				System.err.println("Using fallback case for detecting invalid handele of prepared statement.");
				new Throwable().printStackTrace(System.err);
				return true;
			}
			else{
				return false;
			}
		}
		else{
			return false;
		}
	}
	
	public static boolean isMonetDBBug(final SQLException e){
		//FIXME remove if bug is fixed
		if(e.getMessage() != null){
			return e.getMessage().contains("header expected, got:") | e.getMessage().contains("Unexpected server response");
		}
		else{
			return false;
		}
	}

}
