package de.lmu.ifi.pms.cep.event_mill.sql.compiler;

import org.simpleframework.xml.Attribute;
import org.simpleframework.xml.Element;

import de.lmu.ifi.pms.cep.event_mill.configuration.SQL_DatabaseDriver;


public class DTSA_SQL_WriterImplFactory extends DTSA_SQL_WriterFactory{
	
	public static final String defaultIdentifier = "de.lmu.ifi.pms.cep.event_mill.sql.writer";
	
	@Element(name="driver")
	public final SQL_DatabaseDriver driver;
	
	public DTSA_SQL_WriterImplFactory(final SQL_DatabaseDriver driver) {
		this(defaultIdentifier, driver);		
	}
	
	public DTSA_SQL_WriterImplFactory(@Attribute(name="iri", required=true) final String identifier
			, @Element(name="driver") final SQL_DatabaseDriver driver
			) {
		super(identifier);
		this.driver = driver;
	}

	@Override
	public DTSA_SQL_Writer make() {
		return new DTSA_SQL_WriterImpl(this.driver.translation());
	}
		
}
