package de.lmu.ifi.pms.cep.event_mill.sql.creation;

import de.lmu.ifi.pms.java.math.Math;
import de.lmu.ifi.pms.java.util.collection.array.fixed.FixedArrayNavigableSet;
import de.lmu.ifi.pms.java.util.map.fixed.FixedArrayNavigableMap;

public abstract class SQL_ExpressionFactoryInput {
	
	public abstract FixedArrayNavigableSet<String> schema();

	protected int formatingLength(){
		return Math.max(Integer.toString(this.numberOfDirectInputs(true)).length(),Integer.toString(this.numberOfSubqueries(true)).length());
	}
	
	public abstract int numberOfDirectInputs(final boolean writeAlias);
	
	public abstract int numberOfSubqueries(final boolean writeAlias);
	
	protected abstract String alias(final int directInputNumber, final int formatingLength);
	
	public abstract FixedArrayNavigableMap<String, String> aliasMapping(final int directInputNumber, final int formatingLength);
	
	public abstract void writeTo(StringBuilder sqlQuery, int directInputNumber, final int subqueryNumber, final int formatingLength, final int indentDepth, final boolean writeAlias);

	@Override
	public final String toString() {
		StringBuilder sqlQuery = new StringBuilder();
		this.writeTo(sqlQuery, 0, 0, this.formatingLength(), 0, false);
		return sqlQuery.toString();
	}

}
