package de.lmu.ifi.pms.cep.examples.access_control;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.util.Iterator;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.lmu.ifi.pms.cep.event_mill.configuration.IOConfiguration;
import de.lmu.ifi.pms.cep.event_mill.console.AbstractConsoleThread;
import de.lmu.ifi.pms.cep.event_mill.io.stream.SinkStream;
import de.lmu.ifi.pms.cep.event_mill.io.stream.StreamIO;


public class RequestAccessConsole extends AbstractConsoleThread{
	
	StreamIO io;
	
	SinkStream request_access;
	
	public RequestAccessConsole(final Iterator<String> immediateCommands, final BufferedReader inputStream, final PrintStream outputStream) {
		super("RequestAccessConsole", immediateCommands, inputStream, outputStream);
		
		try {
			this.io = IOConfiguration.read().streamProvider("de.lmu.ifi.pms.cep.event-mill.prototype").connect("de.lmu.ifi.pms.cep.event-mill.prototype:example.access-control:test");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		
	}

	@Override
	public void run() {
		
		try {
			
			int person = 1;
			
			String command;
			boolean running = true;
			this.outputStream.println("Welcome,");
			this.outputStream.println("Who wants to enter?");
			this.outputStream.println("(For leaving type \"quit\")");
			
			this.request_access = this.io.sinkStream("example.access-control.request-access");

			while(running){
				command = this.nextCommand();
				if(command.equalsIgnoreCase("quit")){
					running = false;
					
					this.outputStream.println("Bye!");
				}
				else if (command.equalsIgnoreCase("persons")){
					int maxPerson = person + 1000;
					while(person < maxPerson){
						
						String name = "person_" + person;
						this.outputStream.println(name);
						
						this.request_access.next();
						this.request_access.setString(1, name);
						this.request_access.nextBlock();
						
						++person;
					}							
				}
				else if(command.length() > 0){
					
					this.request_access.next();
					this.request_access.setString(1, command);
					this.request_access.nextBlock();
					
					this.outputStream.println("Who wants to enter now?");
		
				}
				else{
					this.outputStream.println("Who wants to enter now?");
		
				}
			}
		
		} catch (Throwable e) {
			e.printStackTrace(this.outputStream);
			System.exit(1);
		}

		System.exit(0);
	}
	
	//logging
	protected static final Logger logger = LoggerFactory.getLogger(RequestAccessConsole.class);
	
	@Override
	protected Logger logger(){
		return logger;
	}
	
	public static void main(final String[] args) {
		BufferedReader inputStream = new BufferedReader(new InputStreamReader(System.in));
		PrintStream outputStream = System.out;
		
		new RequestAccessConsole(java.util.Arrays.asList(args).iterator(), inputStream, outputStream).start();
	}
	
}
