package de.lmu.ifi.pms.cep.tsa.compiler;

import org.simpleframework.xml.Attribute;

import de.lmu.ifi.pms.cep.tsa.time.analysis.ArithmeticAnalyzerFactory;
import de.lmu.ifi.pms.cep.tsa.time.analysis.CombinedArithmeticAnalyzerFactory;

public class TSA_DefaultDifferencerFactory extends TSA_DifferencerFactory {
	
	//FIXME serialization
	final ArithmeticAnalyzerFactory analyserFactory;
	
	public static final String defaultIdentifier = "de.lmu.ifi.pms.cep.tsa.differencer.default";
	
	public TSA_DefaultDifferencerFactory(){
		this(defaultIdentifier);
	}
	
	public TSA_DefaultDifferencerFactory(@Attribute(name="iri", required=true) final String identifier){
		this(identifier, new CombinedArithmeticAnalyzerFactory());
	}
	
	public TSA_DefaultDifferencerFactory(@Attribute(name="iri", required=true) final String identifier
			, final ArithmeticAnalyzerFactory analyserFactory
			) {
		super(identifier);
		this.analyserFactory = analyserFactory;
	}
	
	@Override
	public TSA_Differencer make() {
		return new TSA_DefaultDifferencer(this.analyserFactory);
	}

}
