package de.lmu.ifi.pms.cep.tsa.conditions;

import org.simpleframework.xml.Attribute;

import de.lmu.ifi.pms.cep.tsa.schema.BasicType;
import de.lmu.ifi.pms.cep.tsa.schema.BasicTypeID;


public class BooleanValue extends BasicTypeValue {

	@Attribute(name="value")
	public final boolean value;
	
	public BooleanValue(@Attribute(name="value") final boolean value) {
		super(BasicTypeID.BOOLEAN);
		this.value = value;
	}
	
	@Override
	protected int compareValue(final Value<BasicType> value) {
		return (this.value ? 1 : 0) - (((BooleanValue)value).value ? 1 : 0);
	}
	
	@Override
	protected int valueHashcode() {
		return Boolean.valueOf(this.value).hashCode();
	}
	
	@Override
	public String toString() {
		return String.format("%b : %s", this.value, this.type.toString());
	}
	
}
