package de.lmu.ifi.pms.cep.tsa.conditions;

import org.simpleframework.xml.Element;
import org.simpleframework.xml.ElementList;
import org.simpleframework.xml.Root;

import de.lmu.ifi.pms.cep.tsa.schema.AType;
import de.lmu.ifi.pms.cep.tsa.schema.NoType;


@Root(name="plus")
public class Plus<TypeClass extends AType> extends TupleFunction<TypeClass> {

	public Plus(final TypeClass type, final Term<?> argument1, final Term<?> argument2) {
		super(TupleFunctionID.PLUS, type, argument1, argument2);
	}
	
	@SuppressWarnings("unchecked")
	Plus(@Element(name="type", required=false) final TypeClass type, @ElementList(entry="term", inline=true, required=false, empty=false)  final java.util.ArrayList<Term<?>> arguments) {
		super(TupleFunctionID.PLUS, (type==null ? (TypeClass)NoType.instance : type), arguments);
	}
	
	@Override
	public Plus<TypeClass> newTerm(final Term<?>... arguments) {
		return new Plus<TypeClass>(this.type, arguments[0],arguments[1]);
	}

}