package de.lmu.ifi.pms.cep.tsa.conditions;

import org.simpleframework.xml.Attribute;
import org.simpleframework.xml.Element;
import org.simpleframework.xml.ElementList;

import de.lmu.ifi.pms.cep.tsa.schema.AType;
import de.lmu.ifi.pms.cep.tsa.schema.NoType;



public class UserTupleFunction<TypeClass extends AType> extends TupleFunction<TypeClass> {
	
	@Attribute(name="name")
	String getName(){
		return this.name;
	}
	
	@SuppressWarnings("unchecked")
	public UserTupleFunction(@Attribute(name="name")final String name, @Element(name="type", required=false) final TypeClass type, @ElementList(entry="term", inline=true, required=false, empty=false)  final java.util.ArrayList<Term<?>> arguments) {
		super(TupleFunctionID.USER, name, (type==null ? (TypeClass)NoType.instance: type), arguments);
	}
	
	public UserTupleFunction(@Attribute(name="name")final String name, final TypeClass type, final Term<?>... arguments) {
		super(TupleFunctionID.USER, name, type, arguments);
	}

	@Override
	public UserTupleFunction<TypeClass> newTerm(final Term<?>... arguments) {
		return new UserTupleFunction<TypeClass>(this.name, this.type, arguments);
	}
}
