package de.lmu.ifi.pms.cep.tsa.operators;

import static de.lmu.ifi.pms.cep.event_mill.sql.creation.SQL_QueryBuildHelper.indentTab;

import org.simpleframework.xml.Element;
import org.simpleframework.xml.ElementList;

import de.lmu.ifi.pms.cep.tsa.schema.TemporalStreamSchema;

import de.lmu.ifi.pms.java.util.collection.Collection;
import de.lmu.ifi.pms.java.util.collection.array.fixed.FixedArray;
import de.lmu.ifi.pms.java.util.collection.array.fixed.FixedArrayNavigableSet;
import de.lmu.ifi.pms.java.util.collection.fixed.FixedCollection;


public class TSA_GroupingOperator extends TSA_BasicOperator
{
	public final FixedArrayNavigableSet<String> grouping_attributes;
	
	@ElementList(name="grouping-attributes",entry="attribute")
	java.util.ArrayList<String> getAttributeList(){
		return new java.util.ArrayList<String>(this.grouping_attributes.javaCollection());
	}
	
	@Element(name="group-attribute")
	public final String group_attribute;
	
	public TSA_GroupingOperator(final String origin, final FixedArray<String> grouping_attributes, final String group_attribute){
		this(new FixedArray<String>(false, origin), grouping_attributes, group_attribute);
	}
	
	public TSA_GroupingOperator(@ElementList(entry="origin", inline=true) final java.util.ArrayList<String> origin
			, @ElementList(name="grouping-attributes",entry="attribute") final java.util.ArrayList<String> grouping_attributes
			, @Element(name="group-attribute") final String group_attribute){
		this(new FixedArray<String>(origin), new FixedArray<String>(grouping_attributes), group_attribute);
	}
	
	public TSA_GroupingOperator(final FixedCollection<String> origin, final FixedArray<String> grouping_attributes, final String group_attribute)
	{
		super(TSA_BasicOperatorID.GROUPING, origin);
		//FIXME check attributes and selection conditions
		this.grouping_attributes = TemporalStreamSchema.normalizeforRetain(grouping_attributes);
		this.group_attribute = group_attribute;
	}
	
	@Override
	public int inputArity() {
		return 1;
	}
	
	
	@Override
	public boolean isMonotonic(Collection<TemporalStreamSchema> inputs){
		return false;
	}

	@Override
	public TemporalStreamSchema apply(final Collection<TemporalStreamSchema> inputs) {
		//throw new UnimplementedMethodError();
		return null;//FIXME implement
	}
	
	@Override
	public void check(final Collection<TemporalStreamSchema> inputs) {
		//FIXME implement
	}
	
	@Override
	public void writeTo(final StringBuilder sb, final int indentDepthFirstLine, final int indentDepth) {
		indentTab(sb, indentDepthFirstLine);
		sb.append(this.ID.toString());
		assert this.grouping_attributes.size() > 0;
		sb.append("[");
		for(String grouping_attribute: this.grouping_attributes){
			sb.append(grouping_attribute);
			sb.append(", ");
		}
		sb.setLength(sb.length() - ", ".length());
		sb.append("]");
	}
	
}
