package de.lmu.ifi.pms.cep.tsa.time.functions;

import org.simpleframework.xml.core.Resolve;



public final class UnityTimeFunction extends TimeFunction {
	
	public static final UnityTimeFunction instance = new UnityTimeFunction();

	private UnityTimeFunction() {
		super();		
	}
	
	@Resolve
	protected UnityTimeFunction resolve(){
		return instance;
	}

	@Override
	public void apply(final long[] arguments, final int argStart, final long[] results, final int resultStart) {
		assert argStart >= 0;
		assert resultStart >= 0;
		assert arguments.length >= argStart + this.argumentArity();
		assert results.length >= resultStart + this.resultArity(); 
		
		results[resultStart] = arguments[argStart];
	}

	@Override
	public final int argumentArity() {
		return 0;
	}

	@Override
	public final int resultArity() {
		return 0;
	}
	
}
