package de.lmu.ifi.pms.java.lang.iteration;

import java.util.Iterator;

import de.lmu.ifi.pms.java.util.adaption.CollectionAdapter;
import de.lmu.ifi.pms.java.util.collection.Collection;
import de.lmu.ifi.pms.java.util.collection.array.fixed.FixedArray;



public class ComposedIterable<Type> extends AbstractIterable<Type> {
	
	private final FixedArray<Iterable<Type>> iterations;
	
	public ComposedIterable(final Iterable<Type>... iterations){
		this(new FixedArray<Iterable<Type>>(iterations));
	}
	
	public ComposedIterable(final Collection<Iterable<Type>> iterations){
		this(new FixedArray<Iterable<Type>>(iterations));
	}
	
	public ComposedIterable(final FixedArray<Iterable<Type>> iterations){
		super();
		this.iterations = iterations;
	}

	@Override
	public Iterator<Type> iterator() {
		return new FixedComposedIterator<Type>(new CollectionAdapter<Iterable<Type>, Iterator<Type>>(this.iterations){
			@Override
			public Iterator<Type> adapt(final Iterable<Type> source) {
				return source.iterator();
			}
		});
	}

}
