/**
 * 
 */
package de.lmu.ifi.pms.java.lang.iteration;

import java.util.Iterator;
import java.util.NoSuchElementException;

import de.lmu.ifi.pms.java.util.filter.Filter;



public abstract class FilteredIterator<Type> extends AbstractFixedIterator<Type> implements Filter<Type>{

	private final Iterator<? extends Type> sourceIterator;
	
	private Type next = null;
	
	public FilteredIterator(final Iterator<? extends Type> sourceIterator) {
		super();
		this.sourceIterator = sourceIterator;
	}

	@Override
	public final boolean hasNext() {
		while(this.next == null && this.sourceIterator.hasNext()){
			this.next = this.sourceIterator.next();
			if(!this.accepts(this.next)){
				this.next = null;
			}
		}
		return this.next != null;
	}

	@Override
	public final Type next() {
		if(this.hasNext()){
			final Type next = this.next;
			this.next = null;
			return next;
		}
		else{
			throw new NoSuchElementException();//TODO better exception
		}
	}
	
	@Override
	public abstract boolean accepts(Type element);
	
	@Override
	@SuppressWarnings({ "unchecked", "cast" })
	public boolean accepts(final int element) {
		return this.accepts((Type)(Object)element);
	}

	@Override
	@SuppressWarnings({ "unchecked", "cast" })
	public boolean accepts(final long element) {
		return this.accepts((Type)(Object)element);
	}

	@Override
	@SuppressWarnings({ "unchecked", "cast" })
	public boolean accepts(final float element) {
		return this.accepts((Type)(Object)element);
	}

	@Override
	@SuppressWarnings({ "unchecked", "cast" })
	public boolean accepts(final double element) {
		return this.accepts((Type)(Object)element);
	}

	@Override
	@SuppressWarnings({ "unchecked", "cast" })
	public boolean accepts(final byte element) {
		return this.accepts((Type)(Object)element);
	}

	@Override
	@SuppressWarnings({ "unchecked", "cast" })
	public boolean accepts(final short element) {
		return this.accepts((Type)(Object)element);
	}

	@Override
	@SuppressWarnings({ "unchecked", "cast" })
	public boolean accepts(final char element) {
		return this.accepts((Type)(Object)element);
	}

	@Override
	@SuppressWarnings({ "unchecked", "cast" })
	public boolean accepts(final boolean element) {
		return this.accepts((Type)(Object)element);
	}

			
}