package de.lmu.ifi.pms.java.lang.iteration;

import de.lmu.ifi.pms.development.UnimplementedMethodError;

public class JavaIteratorExtendibleWrapper<Type> extends AbstractExtendibleIterator<Type> {
	
	private final java.util.Collection<? extends Type> javaCollection;
	private final java.util.Iterator<? extends Type> javaIterator;

	public JavaIteratorExtendibleWrapper(final java.util.Collection<? extends Type> javaCollection) {
		super();
		this.javaCollection = javaCollection;
		this.javaIterator = this.javaCollection.iterator();
	}

	@Override
	public final boolean hasNext() {
		return this.javaIterator.hasNext();
	}

	@Override
	public final Type next() {
		return this.javaIterator.next();
	}
	
	@Override
	public void remove() {
		this.javaIterator.remove();
	}
	
	@Override	
	public void insert(final Type value) {
		//FIXME implement
		throw new UnimplementedMethodError();
	}
	@Override
	public void replace(final Type newValue) {
		//FIXME implement
		throw new UnimplementedMethodError();
	}

}
