package de.lmu.ifi.pms.java.util.adaption;

import de.lmu.ifi.pms.java.lang.iteration.AbstractIterable;
import de.lmu.ifi.pms.java.lang.iteration.FixedIterator;
import de.lmu.ifi.pms.java.util.collection.array.fixed.FixedArray;

public abstract class IterationAdapter<SourceType, IterationType> extends AbstractIterable<IterationType> implements Adapter<SourceType, IterationType>{

	private final Iterable<? extends SourceType> source;	

	public IterationAdapter(final Iterable<? extends SourceType> source) {
		super();
		this.source = source;
	}
	
	public IterationAdapter(final SourceType[] source) {
		super();
		this.source = new FixedArray<SourceType>(false, source);
	}

	@Override
	public FixedIterator<IterationType> iterator() {
		return new IteratorAdapterImpl<SourceType, IterationType>(this.source.iterator(), this);
	}
		
	@Override
	public abstract IterationType adapt(SourceType source);
}
