package de.lmu.ifi.pms.java.util.collection.array;

import static de.lmu.ifi.pms.java.util.collection.AbstractCollection.*;

import java.lang.reflect.Array;
import java.util.Comparator;

import de.lmu.ifi.pms.java.util.comparator.ComparableWrapper;


@SuppressWarnings("serial")
public final class Arrays{
	
	private Arrays(){
		
	}
	
	public final static int length(final Object array){
		return java.lang.reflect.Array.getLength(array);
	}

	public final static boolean isArray(final Object o){
		return o.getClass().isArray();
	}

	@SuppressWarnings("rawtypes")
	public final static Object getUntypedInitializedArray(final Class type, final int size){
		Object array = getUntypedArray(type, size);
		TypeConstant.get(type).initArray(array);
		return array;
	}

	@SuppressWarnings("rawtypes")
	public final static Object getUntypedArray(final Class type, final int size){
		return java.lang.reflect.Array.newInstance(type, size);
	}

	@SuppressWarnings("unchecked")
	public final static <Type> Type[] getArray(final Class<Type> type, final int size){
		return (Type[]) java.lang.reflect.Array.newInstance(type, size);
	}

	@SuppressWarnings("unchecked")
	public final static <Type> Type[] getArray(final Type[] a, final int size){
		return getArray((Class<Type>) a.getClass().getComponentType(), size);
	}

	public final static double[] getArray(final double[] a, final int size){
		return new double[size];
	}
	
	public final static void fill(final boolean[] a, final boolean value){
		int length = a.length;
		switch (length) {
		case 0:{
			return;
		}
		case 1:{
			a[0] = value;
			return;
		}
		default:
			a[0] = value;
			a[1] = value;
			length = length - 2;
			int cl;
			for(int il = 2; length > 0; il = il << 1, length = length - cl){
				cl = (il < length ? il : length);
				System.arraycopy(a, 0, a, il, cl);
			}
			return;
		}
	}
	
	public final static void fill(final char[] a, final char value){
		int length = a.length;
		switch (length) {
		case 0:{
			return;
		}
		case 1:{
			a[0] = value;
			return;
		}
		default:
			a[0] = value;
			a[1] = value;
			length = length - 2;
			int cl;
			for(int il = 2; length > 0; il = il << 1, length = length - cl){
				cl = (il < length ? il : length);
				System.arraycopy(a, 0, a, il, cl);
			}
			return;
		}
	}
	
	public final static void fill(final byte[] a, final byte value){
		int length = a.length;
		switch (length) {
		case 0:{
			return;
		}
		case 1:{
			a[0] = value;
			return;
		}
		default:
			a[0] = value;
			a[1] = value;
			length = length - 2;
			int cl;
			for(int il = 2; length > 0; il = il << 1, length = length - cl){
				cl = (il < length ? il : length);
				System.arraycopy(a, 0, a, il, cl);
			}
			return;
		}
	}
	
	public final static void fill(final short[] a, final short value){
		int length = a.length;
		switch (length) {
		case 0:{
			return;
		}
		case 1:{
			a[0] = value;
			return;
		}
		default:
			a[0] = value;
			a[1] = value;
			length = length - 2;
			int cl;
			for(int il = 2; length > 0; il = il << 1, length = length - cl){
				cl = (il < length ? il : length);
				System.arraycopy(a, 0, a, il, cl);
			}
			return;
		}
	}
	
	public final static void fill(final int[] a, final int value){
		int length = a.length;
		switch (length) {
		case 0:{
			return;
		}
		case 1:{
			a[0] = value;
			return;
		}
		default:
			a[0] = value;
			a[1] = value;
			length = length - 2;
			int cl;
			for(int il = 2; length > 0; il = il << 1, length = length - cl){
				cl = (il < length ? il : length);
				System.arraycopy(a, 0, a, il, cl);
			}
			return;
		}
	}

	public final static void fill(final long[] a, final long value){
		int length = a.length;
		switch (length) {
		case 0:{
			return;
		}
		case 1:{
			a[0] = value;
			return;
		}
		default:
			a[0] = value;
			a[1] = value;
			length = length - 2;
			int cl;
			for(int il = 2; length > 0; il = il << 1, length = length - cl){
				cl = (il < length ? il : length);
				System.arraycopy(a, 0, a, il, cl);
			}
			return;
		}
	}
	
	public final static void fill(final float[] a, final float value){
		int length = a.length;
		switch (length) {
		case 0:{
			return;
		}
		case 1:{
			a[0] = value;
			return;
		}
		default:
			a[0] = value;
			a[1] = value;
			length = length - 2;
			int cl;
			for(int il = 2; length > 0; il = il << 1, length = length - cl){
				cl = (il < length ? il : length);
				System.arraycopy(a, 0, a, il, cl);
			}
			return;
		}
	}
	
	public final static void fill(final double[] a, final double value){
		int length = a.length;
		switch (length) {
		case 0:{
			return;
		}
		case 1:{
			a[0] = value;
			return;
		}
		default:
			a[0] = value;
			a[1] = value;
			length = length - 2;
			int cl;
			for(int il = 2; length > 0; il = il << 1, length = length - cl){
				cl = (il < length ? il : length);
				System.arraycopy(a, 0, a, il, cl);
			}
			return;
		}
	}

	public final static <Type> void fill(final Type[] a, final Type value){
		int length = a.length;
		switch (length) {
		case 0:{
			return;
		}
		case 1:{
			a[0] = value;
			return;
		}
		default:
			a[0] = value;
			a[1] = value;
			length = length - 2;
			int cl;
			for(int il = 2; length > 0; il = il << 1, length = length - cl){
				cl = (il < length ? il : length);
				copy(a, 0, a, il, cl);
			}
			return;
		}
	}
	
	public final static <Type> void fillFactory(final Type[] a, final ValueFactory<Type> valueFactory){
		final int length = a.length;
		for(int index = 0; index < length; ++index){
			a[index] = valueFactory.make(index);
		}
	}
	
	public static abstract class ValueFactory<Type>{
		public abstract Type make(int index);		
	}

	public final static <Type> Type[] clone(final Type[] a){
		return copy(a, 0, 0, a.length, a.length);
	}

	public final static <Type> void copy(final Type[] source, final int sourceStart, final Type[] destination, final int destinationStart, final int count){
		System.arraycopy(source, sourceStart, destination, destinationStart, count);
	}

	public static <Type> Type[] copy(final Type[] source, final int sourceStart, final int destinationStart, final int count, final int size){
		Type[] result = getArray(source, size);
		copy(source, sourceStart, result, destinationStart, count);
		return result;
	}

	public final static <Type> Type[] invert(final Type[] a){
		Type[] result = getArray(a, a.length);
		for(int i=0, j=a.length-1; j >= 0; ++i, --j){
			result[i] = a[j];
		}
		return result;
	}

	public final static int[] invert(final int[] a){
		int[] result = new int[a.length];
		for(int i=0, j=a.length-1; j >= 0; ++i, --j){
			result[i] = a[j];
		}
		return result;
	}

	public final static Object get(final int index, final Object array){
		return java.lang.reflect.Array.get(array, index);
	}

	public final static int getInt(final int index, final Object array){
		try{
			return java.lang.reflect.Array.getInt(array, index);
		}
		catch (IllegalArgumentException e) {
			return toInt(get(index, array));
		}
	}

	public final static long getLong(final int index, final Object array){
		try{
			return java.lang.reflect.Array.getLong(array, index);
		}
		catch (IllegalArgumentException e) {
			return toLong(get(index, array));
		}
	}

	public final static float getFloat(final int index, final Object array){
		try{
			return java.lang.reflect.Array.getFloat(array, index);
		}
		catch (IllegalArgumentException e) {
			return toFloat(get(index, array));
		}
	}

	public final static double getDouble(final int index, final Object array){
		try{
			return java.lang.reflect.Array.getDouble(array, index);
		}
		catch (IllegalArgumentException e) {
			return toDouble(get(index, array));
		}
	}

	public final static byte getByte(final int index, final Object array){
		try{
			return java.lang.reflect.Array.getByte(array, index);
		}
		catch (IllegalArgumentException e) {
			return toByte(get(index, array));
		}
	}

	public final static short getShort(final int index, final Object array){
		try{
			return java.lang.reflect.Array.getShort(array, index);
		}
		catch (IllegalArgumentException e) {
			return toShort(get(index, array));
		}
	}

	public final static char getChar(final int index, final Object array){
		try{
			return java.lang.reflect.Array.getChar(array, index);
		}
		catch (IllegalArgumentException e) {
			return toChar(get(index, array));
		}
	}

	public final static boolean getBoolean(final int index, final Object array){
		try{
			return java.lang.reflect.Array.getBoolean(array, index);
		}
		catch (IllegalArgumentException e) {
			return toBoolean(get(index, array));
		}
	}

	public final static <Type> void set(final int index, final Object array, final Type value){
		java.lang.reflect.Array.set(array, index, value);
	}

	public final static void set(final int index, final Object array, final int value){
		try{
			java.lang.reflect.Array.setInt(array, index, value);
		}
		catch (IllegalArgumentException e) {
			java.lang.reflect.Array.set(array, index, value);
		}
	}

	public final static void set(final int index, final Object array, final long value){
		try{
		java.lang.reflect.Array.setLong(array, index, value);
		}
		catch (IllegalArgumentException e) {
			java.lang.reflect.Array.set(array, index, value);
		}
	}

	public final static void set(final int index, final Object array, final float value){
		try{
			java.lang.reflect.Array.setFloat(array, index, value);
		}
		catch (IllegalArgumentException e) {
			java.lang.reflect.Array.set(array, index, value);
		}
	}

	public final static void set(final int index, final Object array, final double value){
		try{
			java.lang.reflect.Array.setDouble(array, index, value);
		}
		catch (IllegalArgumentException e) {
			java.lang.reflect.Array.set(array, index, value);
		}
	}

	public final static void set(final int index, final Object array, final short value){
		try{
			java.lang.reflect.Array.setShort(array, index, value);
		}
		catch (IllegalArgumentException e) {
			java.lang.reflect.Array.set(array, index, value);
		}
	}

	public final static void set(final int index, final Object array, final byte value){
		try{
			java.lang.reflect.Array.setByte(array, index, value);
		}
		catch (IllegalArgumentException e) {
			java.lang.reflect.Array.set(array, index, value);
		}
	}

	public final static void set(final int index, final Object array, final char value){
		try{
			java.lang.reflect.Array.setChar(array, index, value);
		}
		catch (IllegalArgumentException e) {
			java.lang.reflect.Array.set(array, index, value);
		}
	}

	public final static void set(final int index, final Object array, final boolean value){
		try{
			java.lang.reflect.Array.setBoolean(array, index, value);
		}
		catch (IllegalArgumentException e) {
			java.lang.reflect.Array.set(array, index, value);
		}
	}

	public final static Object first(final Object array){
		return get(0, array);
	}

	public final static Object last(final Object array){
		return get(length(array)-1, array);
	}

	/* (non-Javadoc)
	 * @see extension.java.util.collection.array.AbstractModifyableArray#insertIndexDropLast(int, java.lang.Object)
	 */
	public final static <Type> void insertIndexDropLast(final Object array, final int index, final Type value) {
		System.arraycopy(array, index, array, index + 1, length(array) - index - 1);
		 set(index, array, value);
	}

	public final static <Type> void addFirstDropLast(final Object array, final Type value){
		 insertIndexDropLast(array, 0, value);
	}
	
	/*
	public static String toString(final boolean[] a){
		StringBuilder builder = new StringBuilder();
		builder.append("[ ");
		if(a.length > 0){
			builder.append(a[0]);
			for(int i = 1; i < a.length; ++i){
				builder.append(", ");
				builder.append(a[i]);
			}
		}
		builder.append(" ]");
		return builder.toString();
	}
	
	public static String toString(final byte[] a){
		StringBuilder builder = new StringBuilder();
		builder.append("[ ");
		if(a.length > 0){
			builder.append(a[0]);
			for(int i = 1; i < a.length; ++i){
				builder.append(", ");
				builder.append(a[i]);
			}
		}
		builder.append(" ]");
		return builder.toString();
	}
	
	public static String toString(final short[] a){
		StringBuilder builder = new StringBuilder();
		builder.append("[ ");
		if(a.length > 0){
			builder.append(a[0]);
			for(int i = 1; i < a.length; ++i){
				builder.append(", ");
				builder.append(a[i]);
			}
		}
		builder.append(" ]");
		return builder.toString();
	}
	
	public static String toString(final int[] a){
		StringBuilder builder = new StringBuilder();
		builder.append("[ ");
		if(a.length > 0){
			builder.append(a[0]);
			for(int i = 1; i < a.length; ++i){
				builder.append(", ");
				builder.append(a[i]);
			}
		}
		builder.append(" ]");
		return builder.toString();
	}
	
	
	public static String toString(final long[] a){
		StringBuilder builder = new StringBuilder();
		builder.append("[ ");
		if(a.length > 0){
			builder.append(a[0]);
			for(int i = 1; i < a.length; ++i){
				builder.append(", ");
				builder.append(a[i]);
			}
		}
		builder.append(" ]");
		return builder.toString();
	}
	
	public static String toString(final float[] a){
		StringBuilder builder = new StringBuilder();
		builder.append("[ ");
		if(a.length > 0){
			builder.append(a[0]);
			for(int i = 1; i < a.length; ++i){
				builder.append(", ");
				builder.append(a[i]);
			}
		}
		builder.append(" ]");
		return builder.toString();
	}
	
	public static String toString(final double[] a){
		StringBuilder builder = new StringBuilder();
		builder.append("[ ");
		if(a.length > 0){
			builder.append(a[0]);
			for(int i = 1; i < a.length; ++i){
				builder.append(", ");
				builder.append(a[i]);
			}
		}
		builder.append(" ]");
		return builder.toString();
	}
	
	public static String toString(final char[] a){
		if(a.length > 0){
			StringBuilder builder = new StringBuilder();
			builder.append("[ ");
			builder.append(a[0]);
			for(int i = 1; i < a.length; ++i){
				builder.append(", ");
				builder.append(a[i]);
			}
			builder.append(" ]");
			return builder.toString();
		}
		else{
			return "[]";
		}
	}
	
	public static String toString(final Object[] a){
		StringBuilder builder = new StringBuilder();
		builder.append("[ ");
		if(a.length > 0){
			builder.append(toString(a[0]));
			for(int i = 1; i < a.length; ++i){
				builder.append(", ");
				builder.append(toString(a[i]));
			}
		}
		builder.append(" ]");
		return builder.toString();
	}
	*/
	
	public static String toString(final Object a){
		if(a.getClass().isArray()){
			if(a instanceof boolean[]){
				return toString(a);
			}
			if(a instanceof byte[]){
				return toString(a);
			}
			if(a instanceof short[]){
				return toString(a);
			}
			if(a instanceof int[]){
				return toString(a);
			}
			if(a instanceof long[]){
				return toString(a);
			}
			if(a instanceof float[]){
				return toString(a);
			}
			if(a instanceof double[]){
				return toString(a);
			}
			if(a instanceof char[]){
				return toString(a);
			}
			if(a instanceof Object[]){
				return toString(a);
			}
			else{
				//impossible case
				throw new Error("programming fault: Assumption impossible case wrong");
			}
		}
		else{
			return a.toString();
		}
	}
	
	public static <Type> int merge(final Type[] set1, final int fromIndex1, final int toIndex1, final Type[] set2, final int fromIndex2, final int toIndex2, final Type[] newSet, final int fromIndexNew, Comparator<? super Type> comparator, final boolean retainDublicates, final int[] sourcePosition1, final int[] sourcePosition2, final int[] sourcePositionNew){
		//index checks
		if(fromIndex1 < 0){
			throw new ArrayIndexOutOfBoundsException(fromIndex1);
		}
		if(toIndex1 > set1.length){
			throw new ArrayIndexOutOfBoundsException(toIndex1);
		}
		if(fromIndex2 < 0){
			throw new ArrayIndexOutOfBoundsException(fromIndex2);
		}
		if(toIndex2 > set2.length){
			throw new ArrayIndexOutOfBoundsException(toIndex2);
		}
		if(fromIndexNew < 0){
			throw new ArrayIndexOutOfBoundsException(fromIndexNew);
		}
		if(set1 == newSet){
			//potential write collissions
			throw new IllegalArgumentException();
		}
		if(set2 == newSet){
			//potential write collissions
			throw new IllegalArgumentException();
		}
		if(sourcePositionNew != null){
			if(sourcePositionNew.length < newSet.length){
				throw new IllegalArgumentException();
				//TODO better exception
			}
			if(sourcePosition1 == null | sourcePosition2 == null){
				throw new IllegalArgumentException();
				//TODO better exception
			}
			else{
				if(sourcePosition1.length < set1.length){
					throw new IllegalArgumentException();
					//TODO better exception
				}
				if(sourcePosition1 == sourcePositionNew){
					throw new IllegalArgumentException();
					//TODO better exception
				}
				if(sourcePosition2.length < set2.length){
					throw new IllegalArgumentException();
					//TODO better exception
				}
				if(sourcePosition2 == sourcePositionNew){
					throw new IllegalArgumentException();
					//TODO better exception
				}
			}
		}
		
		final boolean trackPositions = sourcePositionNew != null;
		
		//ensure comparator
		if(comparator == null){
			@SuppressWarnings("unchecked")
			final Comparator<Type> comparableComparator = ComparableWrapper.wrapper;
			comparator = comparableComparator;
		}
		
		final int length1 = toIndex1 - fromIndex1;
		final int length2 = toIndex2 - fromIndex2;
		int index1 = fromIndex1;
		int index2 = fromIndex2;
		int newSetIndex = fromIndexNew;
		
		if(length1 <= 0){
			if(length2 <= 0){
				//no need to copy					
			}
			else{
				System.arraycopy(set2, fromIndex2, newSet, fromIndexNew, length2);
			}
			if(trackPositions){
				for(; index2 < toIndex2; ++index2, ++newSetIndex){
					sourcePositionNew[newSetIndex] = sourcePosition2[index2];
				}
			}
			else{
				newSetIndex += length2;
			}
		}
		else if(length2 <= 0){
			assert length1 > 0;//case length1 <= 0 already treated by previous case
			System.arraycopy(set1, fromIndex1, newSet, fromIndexNew, length1);
			if(trackPositions){
				for(; index1 < toIndex1; ++index1, ++newSetIndex){
					sourcePositionNew[newSetIndex] = sourcePosition1[index1];
				}
			}
			else{
				newSetIndex += length1;
			}
		}
		else{
			assert length1 > 0;
			assert length2 > 0;
			final int cmp12 = comparator.compare(set1[toIndex1 - 1], set2[fromIndex2]);
			final int cmp21 = comparator.compare(set2[toIndex2 - 1], set1[fromIndex1]);
			if(cmp12 < 0 || (retainDublicates & cmp12 == 0)){			
				System.arraycopy(set1, fromIndex1, newSet, newSetIndex, length1);
				if(trackPositions){
					for(; index1 < toIndex1; ++index1, ++newSetIndex){
						sourcePositionNew[newSetIndex] = sourcePosition1[index1];
					}
				}
				else{
					newSetIndex += length1;
				}
				System.arraycopy(set2, fromIndex2, newSet, newSetIndex, length2);
				if(trackPositions){
					for(; index2 < toIndex2; ++index2, ++newSetIndex){
						sourcePositionNew[newSetIndex] = sourcePosition2[index2];
					}
				}
				else{
					newSetIndex += length2;
				}
			}
			else if(cmp21 < 0 || (retainDublicates & cmp21 == 0)){			
				System.arraycopy(set2, fromIndex2, newSet, newSetIndex, length2);
				if(trackPositions){
					for(; index2 < toIndex2; ++index2, ++newSetIndex){
						sourcePositionNew[newSetIndex] = sourcePosition2[index2];
					}
				}
				else{
					newSetIndex += length2;
				}
				System.arraycopy(set1, fromIndex1, newSet, newSetIndex, length1);
				if(trackPositions){
					for(; index1 < toIndex1; ++index1, ++newSetIndex){
						sourcePositionNew[newSetIndex] = sourcePosition1[index1];
					}
				}
				else{
					newSetIndex += length1;
				}
			}
			else{
				assert length1 > 0;
				assert length2 > 0;
				{
					Type current1 = set1[index1];
					Type current2 = set2[index2];
					int cmp;
					do{
						cmp = comparator.compare(current1, current2);
						if(cmp < 0){
							newSet[newSetIndex] = current1;
							if(trackPositions){
								sourcePositionNew[newSetIndex] = sourcePosition1[index1];
							}
							++newSetIndex;
							++index1;
							if(index1 < toIndex1){
								current1 = set1[index1];
							}
							else{
								break;
							}
						}
						else if(cmp == 0){
							newSet[newSetIndex] = current1;
							if(trackPositions){
								sourcePositionNew[newSetIndex] = sourcePosition1[index1];
							}
							++index1;
							if(retainDublicates){
								++newSetIndex;
								newSet[newSetIndex] = current2;
								if(trackPositions){
									sourcePositionNew[newSetIndex] = sourcePosition2[index2];
								}
							}
							++newSetIndex;
							++index2;
							if(index1 < toIndex1 && index2 < toIndex2){
								current1 = set1[index1];
								current2 = set2[index2];
							}
							else{
								break;
							}
						}
						else{
							newSet[newSetIndex] = current2;
							if(trackPositions){
								sourcePositionNew[newSetIndex] = sourcePosition2[index2];
							}
							++newSetIndex;
							++index2;
							if(index2 < toIndex2){
								current2 = set2[index2];
							}
							else{
								break;
							}
						}
					} while (true);
				}
				//at most one of the following two cases will be entered as index1 >= length1 or index2 >= length2
				if(index1 < toIndex1){
					int rest = toIndex1 - index1;
					System.arraycopy(set1, index1, newSet, newSetIndex, rest);
					if(trackPositions){
						while(index1 < toIndex1){
							sourcePositionNew[newSetIndex] = sourcePosition1[index1];
							++newSetIndex;
							++index1;
						}
					}
					else{
						//index1 += rest
						newSetIndex += rest;
					}
				}
				if(index2 < toIndex2){
					int rest = toIndex2 - index2;
					System.arraycopy(set2, index2, newSet, newSetIndex, rest);
					if(trackPositions){
						while(index2 < toIndex2){
							sourcePositionNew[newSetIndex] = sourcePosition2[index2];
							++newSetIndex;
							++index2;
						}
					}
					else{
						//index1 += rest
						newSetIndex += rest;
					}
				}
				java.util.Arrays.copyOf(newSet, newSetIndex);
			}
		}
		return newSetIndex;
	}
	
	@SuppressWarnings("unchecked")
	public static <Type> Type[] merge(final Type[] set1, final Type[] set2, final Comparator<? super Type> comparator, final int[] sourcePositionNew){
		//chosse more general componentT
		Class<? super Type> ensuredType;
		if(set1.getClass().getComponentType().isAssignableFrom(set2.getClass().getComponentType())){
			ensuredType = (Class<? super Type>)set1.getClass().getComponentType();
		}
		else{
			ensuredType = (Class<? super Type>)set2.getClass().getComponentType();
		}
		Type[] newSet = (Type[])Arrays.getArray(ensuredType, set1.length + set2.length);
		int[] sourcePosition1;
		int[] sourcePosition2;
		if(sourcePositionNew == null){
			sourcePosition1 = null;
			sourcePosition2 = null;
		}
		else{
			sourcePosition1 = new int[set1.length];
			for (int i = 0; i < sourcePosition1.length; i++) {
				sourcePosition1[i] = i;
			}
			sourcePosition2 = new int[set2.length];
			for (int i = 0, j = set1.length; i < sourcePosition2.length; ++i, ++j) {
				sourcePosition2[i] = j;
			}
		}
		int newSetIndex = merge(set1, 0, set1.length, set2, 0, set2.length, newSet, 0, comparator, false, sourcePosition1, sourcePosition2, sourcePositionNew);
		return java.util.Arrays.copyOf(newSet, newSetIndex);
	}
	
	public final static <Type> int sort(final Type[] array, final int[] sourcePositionsNew, final boolean retainDublicates){
		if(sourcePositionsNew != null){
			for (int i = 0; i < sourcePositionsNew.length; i++) {
				sourcePositionsNew[i] = i;
			}
		}
		return sort(array, array, null, retainDublicates, sourcePositionsNew, sourcePositionsNew);
	}
	
	@SuppressWarnings("unchecked")
	public final static <Type> int sort(final Type[] array, final Type[] newArray, final Comparator<? super Type> comparator, final boolean retainDublicates, final int[] sourcePositions, final int[] sourcePositionsNew){
		int length = array.length;
		int log2BlockSize = 0;
		int numberOfBlocks = length;
		if(numberOfBlocks > 0){
			Type[] src;
			Type[] dest;
			int[] srcPositions;
			int[] destPositions;
			int[] blockEnds = new int[numberOfBlocks];
			for (int i = 0, blockEnd = 1; i < blockEnds.length; ++i, ++blockEnd) {
				blockEnds[i] = blockEnd;
			}
			if(array == newArray){
				src = array;
				dest = (Type[])Array.newInstance(src.getClass().getComponentType(), src.length);
			}
			else{
				src = java.util.Arrays.copyOf(array, array.length);
				dest = newArray;
			}
			if(sourcePositionsNew == null){
				srcPositions = null;
				destPositions = null;
			}
			else{
				if(sourcePositions == null){
					srcPositions = new int[array.length];
					for (int i = 0; i < srcPositions.length; i++) {
						srcPositions[i] = i;
					}
					destPositions = sourcePositionsNew;
				}
				else{
					if(sourcePositions == sourcePositionsNew){
						srcPositions = sourcePositions;
						destPositions = new int[array.length];
					}
					else{
						srcPositions = java.util.Arrays.copyOf(sourcePositions, sourcePositions.length);
						destPositions = sourcePositionsNew;
					}
				}
			}
			boolean trackPositions = (sourcePositionsNew != null);
			while(numberOfBlocks > 1){//more than one set
				int numberOfBlocks_div_2 = numberOfBlocks >>> 1; //equivalent to numberOfBlocks_div_2 = numberOfBlocks div 2
				
				for(int blockPair = 0; blockPair < numberOfBlocks_div_2; ++blockPair){
					int block1 = blockPair << 1;
					int block2 = block1 + 1;
					int block1Start = block1 << log2BlockSize;
					int block1End = blockEnds[block1];
					int block2Start = block2 << log2BlockSize;;
					int block2End = blockEnds[block2];;
					int newBlockStart = block1Start;
					blockEnds[blockPair] = merge(src, block1Start, block1End, src, block2Start, block2End, dest, newBlockStart, comparator, retainDublicates, srcPositions, srcPositions, destPositions);				
				}
				numberOfBlocks = ++numberOfBlocks >>> 1; // equivalent to numberOfBlocks = (numberOfBlocks div 2) + (numberOfBlocks mod 2)
				if(numberOfBlocks_div_2 < numberOfBlocks){
					int block = numberOfBlocks_div_2 << 1;
					int blockStart = block << log2BlockSize;
					int blockEnd = blockEnds[block];
					int newBlockStart = blockStart;
					System.arraycopy(src, blockStart, dest, newBlockStart, blockEnd - blockStart);
					if(trackPositions){
						System.arraycopy(srcPositions, blockStart, destPositions, newBlockStart, blockEnd - blockStart);
					}
					blockEnds[numberOfBlocks_div_2] = blockEnd;
				}
				
				
				Type[] oldDest = dest;
				int[] oldDestPositions = destPositions;
				dest = src;
				destPositions = srcPositions;
				src = oldDest;
				srcPositions = oldDestPositions;
				
				++log2BlockSize;
			}
			
			if(src != newArray){
				System.arraycopy(src, 0, newArray, 0, blockEnds[0]);
			}
			if(srcPositions != sourcePositionsNew){
				System.arraycopy(srcPositions, 0, sourcePositionsNew, 0, blockEnds[0]);
			}
			
			return blockEnds[0];
		}
		else{
			return 0;
		}
	}
	
	public final static <Type> int sortedIntersect(final Type[] set1, final Type[] set2, final Type[] newArray, Comparator<? super Type> comparator){
		int newArrayIndex = 0;
		int index1 = 0;
		int index2 = 0;
		final int length1 = set1.length;
		final int length2 = set2.length;
		//TODO optimization
		if(length1 > 0 & length2 > 0){
			//ensure comparator
			if(comparator == null){
				@SuppressWarnings("unchecked")
				final Comparator<Type> comparableComparator = ComparableWrapper.wrapper;
				comparator = comparableComparator;
			}
			
			assert length1 > 0;
			assert length2 > 0;
			final int cmp12 = comparator.compare(set1[length1 - 1], set2[0]);
			final int cmp21 = comparator.compare(set2[length2 - 1], set1[0]);
			
			if(cmp12 >= 0 & cmp21 >= 0){
				{
					Type current1 = set1[index1];
					Type current2 = set2[index2];
					int cmp;
					do{
						cmp = comparator.compare(current1, current2);
						if(cmp < 0){
							++index1;
							if(index1 < length1){
								current1 = set1[index1];
							}
							else{
								break;
							}
						}
						else if(cmp > 0){
							++index2;
							if(index2 < length2){
								current2 = set2[index2];
							}
							else{
								break;
							}
						}
						else{assert cmp == 0;
							newArray[newArrayIndex] = current1;
							++newArrayIndex;
							++index1;
							++index2;
							if(index1 < length1 && index2 < length2){
								current1 = set1[index1];
								current2 = set2[index2];
							}
							else{
								break;
							}
						}
					} while(true);
				}
			}
		}
		return newArrayIndex;
	}
	
	public final static <Type> int sortedDifference(final Type[] set1, final Type[] set2, final Type[] newArray, Comparator<? super Type> comparator){
		int newArrayIndex = 0;
		int index1 = 0;
		int index2 = 0;
		final int length1 = set1.length;
		final int length2 = set2.length;
		//TODO optimization
		if(length2 == 0){
			if(set1 != newArray){
				System.arraycopy(set1, index1, newArray, newArrayIndex, length1);
			}
			newArrayIndex = length1;
		}else if(length1 > 0){
			assert length2 > 0;
			//ensure comparator
			if(comparator == null){
				@SuppressWarnings("unchecked")
				final Comparator<Type> comparableComparator = ComparableWrapper.wrapper;
				comparator = comparableComparator;
			}
			
			assert length1 > 0;
			assert length2 > 0;
			final int cmp12 = comparator.compare(set1[length1 - 1], set2[0]);
			final int cmp21 = comparator.compare(set2[length2 - 1], set1[0]);
			
			if(cmp12 < 0 | cmp21 < 0){
				if(set1 != newArray){
					System.arraycopy(set1, index1, newArray, newArrayIndex, length1);
				}
				newArrayIndex = length1;
			}
			else { assert cmp12 >= 0 & cmp21 >= 0;
				{
					Type current1 = set1[index1];
					Type current2 = set2[index2];
					int cmp;
					do{
						cmp = comparator.compare(current1, current2);
						if(cmp < 0){
							newArray[newArrayIndex] = current1;
							++newArrayIndex;
							++index1;
							if(index1 < length1){
								current1 = set1[index1];
							}
							else{
								break;
							}
						}
						else if(cmp > 0){
							++index2;
							if(index2 < length2){
								current2 = set2[index2];
							}
							else{
								break;
							}
						}
						else{assert cmp == 0;
							++index1;
							++index2;
							if(index1 < length1 && index2 < length2){
								current1 = set1[index1];
								current2 = set2[index2];
							}
							else{
								break;
							}
						}
					} while(true);
				}
				if(index1 < length1){
					int rest = length1 - index1;
					System.arraycopy(set1, index1, newArray, newArrayIndex, rest);
					newArrayIndex += rest;
				}
			}
		}
		return newArrayIndex;
	}
	
	@SuppressWarnings("unchecked")
	public final static <Type> Type[] sortedSymmetricDifference(final Type[] set1, final Type[] set2, final Comparator<? super Type> comparator){
		Class<? super Type> ensuredType;
		if(set1.getClass().getComponentType().isAssignableFrom(set2.getClass().getComponentType())){
			ensuredType = (Class<? super Type>)set1.getClass().getComponentType();
		}
		else{
			ensuredType = (Class<? super Type>)set2.getClass().getComponentType();
		}
		Type[] newArray = (Type[])Arrays.getArray(ensuredType, set1.length + set2.length);
		int newLength = sortedSymmetricDifference(set1, set2, newArray, comparator);
		return java.util.Arrays.copyOf(newArray, newLength);
	}
	
	public final static <Type> int sortedSymmetricDifference(final Type[] set1, final Type[] set2, final Type[] newArray, Comparator<? super Type> comparator){
		if(set1 == newArray){
			//potential write collissions
			throw new IllegalArgumentException();
		}
		if(set2 == newArray){
			//potential write collissions
			throw new IllegalArgumentException();
		}
		int newArrayIndex = 0;
		int index1 = 0;
		int index2 = 0;
		final int length1 = set1.length;
		final int length2 = set2.length;
		//TODO optimization
		if(length2 == 0){
			System.arraycopy(set1, index1, newArray, newArrayIndex, length1);
			newArrayIndex = length1;
		}else if(length1 == 0){
			System.arraycopy(set2, index2, newArray, newArrayIndex, length2);
			newArrayIndex = length2;
		}else{
			assert length1 > 0;
			assert length2 > 0;
			//ensure comparator
			if(comparator == null){
				@SuppressWarnings("unchecked")
				final Comparator<Type> comparableComparator = ComparableWrapper.wrapper;
				comparator = comparableComparator;
			}
			
			assert length1 > 0;
			assert length2 > 0;
			final int cmp12 = comparator.compare(set1[length1 - 1], set2[0]);
			final int cmp21 = comparator.compare(set2[length2 - 1], set1[0]);
			
			if(cmp12 < 0){
				System.arraycopy(set1, index1, newArray, newArrayIndex, length1);
				newArrayIndex = length1;
				System.arraycopy(set2, index2, newArray, newArrayIndex, length2);
				newArrayIndex += length2;
			}
			else if(cmp21 < 0){
				System.arraycopy(set2, index2, newArray, newArrayIndex, length2);
				newArrayIndex = length2;
				System.arraycopy(set1, index1, newArray, newArrayIndex, length1);
				newArrayIndex += length1;
			}
			else { assert cmp12 >= 0 & cmp21 >= 0;
				{
					Type current1 = set1[index1];
					Type current2 = set2[index2];
					int cmp;
					do{
						cmp = comparator.compare(current1, current2);
						if(cmp < 0){
							newArray[newArrayIndex] = current1;
							++newArrayIndex;
							++index1;
							if(index1 < length1){
								current1 = set1[index1];
							}
							else{
								break;
							}
						}
						else if(cmp > 0){
							newArray[newArrayIndex] = current2;
							++newArrayIndex;
							++index2;
							if(index2 < length2){
								current2 = set2[index2];
							}
							else{
								break;
							}
						}
						else{assert cmp == 0;
							++index1;
							++index2;
							if(index1 < length1 && index2 < length2){
								current1 = set1[index1];
								current2 = set2[index2];
							}
							else{
								break;
							}
						}
					} while(true);
				}
				if(index1 < length1){
					int rest = length1 - index1;
					System.arraycopy(set1, index1, newArray, newArrayIndex, rest);
					newArrayIndex += rest;
				}
				if(index2 < length2){
					int rest = length2 - index2;
					System.arraycopy(set2, index2, newArray, newArrayIndex, rest);
					newArrayIndex += rest;
				}
			}
		}
		return newArrayIndex;
	}

}
