package de.lmu.ifi.pms.java.util.collection.array;


public class SArray<Type> extends Array<Type> {
	
	private final int start;
	
	public SArray(final int startIndex, final int endIndex, final Class<Type> type) {
		this(startIndex, type, endIndex - startIndex + 1);
	}
	
	public SArray(final Class<Type> type, final int size) {
		this(0, type, size);
	}

	public SArray(final int offset, final Class<Type> type, final int size) {
		super(type, size);
		this.start = offset;
	}
	
	public SArray(final Type... values) {
		this(0, values);
	}

	public SArray(final int offset, final Type... values) {
		super(values);
		this.start = offset;
	}

	@Override
	public int minIndex() {
		return super.minIndex() + this.start;
	}
	
	@Override
	public int maxIndex() {
		return super.maxIndex() + this.start;
	}
	
	@Override
	public Type get(final int index) {
		return super.get(index - this.start);
	}
	
	@Override
	public void set(final int index, final Type value) {
		super.set(index - this.start, value);
	}
	
}
