package de.lmu.ifi.pms.java.util.collection.compatibility;

import de.lmu.ifi.pms.java.util.collection.Collection;
import de.lmu.ifi.pms.java.util.collection.javaWrapper.FromJavaExtendibleSetWrapper;

public class HashSet<Type> extends FromJavaExtendibleSetWrapper<Type>{
	
	public HashSet() {
		this(16);
	}
	
	public HashSet(final int initialCapacity) {
		this(initialCapacity, 0.75f);
	}

	public HashSet(final int initialCapacity, final float loadFactor) {
		super(new java.util.HashSet<Type>(initialCapacity, loadFactor));
	}

	public HashSet(final Collection<Type> c){
		this(c.javaCollection());
	}
	
	public HashSet(final java.util.Collection<Type> c){
		super(new java.util.HashSet<Type>(c));
	}
	
}
