/**
 * 
 */
package de.lmu.ifi.pms.java.util.collection.extendible.list;

/**
 * @author Simon Matthias Brodt
 *
 */
public abstract class AbstractDoubleLinkedList<Type, ListEntryType extends DoubleLinkedListEntry<Type, ListEntryType>> extends AbstractSingleLinkedList<Type, ListEntryType> {
	
	final ListEntryType foot;

	public AbstractDoubleLinkedList() {
		super();
		this.foot = this.newListFoot(this.head);
	}
	
	@Override
	public abstract ListEntryType newListHead(AbstractSingleLinkedList<Type, ListEntryType> linkingList);
	
	public abstract ListEntryType newListFoot(ListEntryType head);
	
	@Override
	public abstract ListEntryType newUnlinkedEntry(Type value);
	
	
	public boolean addFirst(final Type value) {
		this.insertBehind(this.foot, this.newUnlinkedEntry(value));
		return true;
	}
	
	public Type first(){
		return this.value(this.next(this.foot));
	}
	
	public void removeFirst(){
		this.removeNext(this.foot);
	}
	
	protected ListEntryType next(final ListEntryType entry){
		return entry.next();
	}
	
	protected void insertBehind(final ListEntryType entry, final ListEntryType newEntry){
		newEntry.insertBehind(entry);
	}
	
	protected void removeNext(final ListEntryType entry){
		entry.removeNext();
	}
	
	protected void removeFollowing(final ListEntryType entry){
		entry.removeFollowing();
	}

}
