package de.lmu.ifi.pms.java.util.collection.fixed.wrapper;

import java.util.Queue;

import de.lmu.ifi.pms.java.lang.iteration.AbstractFixedIterator;
import de.lmu.ifi.pms.java.lang.iteration.FinalIteratorWrapper;
import de.lmu.ifi.pms.java.util.collection.fixed.AbstractFixedQueue;



public class FixedQueueWrapper<Type> extends AbstractFixedQueue<Type> {

	private final Queue<Type> collection;	
	
	public FixedQueueWrapper(final Queue<Type> collection) {
		super();
		this.collection = collection;
	}

	@Override
	public final AbstractFixedIterator<Type> iterator() {
		return new FinalIteratorWrapper<Type>(this.collection.iterator());
	}

	@Override
	public final int size() {
		return this.collection.size();
	}
	
	@Override
	public Type element() {
		return this.collection.element();
	}

	@Override
	public Type peek() {
		return this.collection.peek();
	}

}
