package de.lmu.ifi.pms.java.util.collection.javaWrapper;

import java.util.Comparator;
import java.util.Iterator;

import de.lmu.ifi.pms.java.util.collection.set.SortedSet;
import de.lmu.ifi.pms.java.util.collection.set.AbstractSortedSet.AbstractJavaSortedSet;


public class ToJavaSortedSetWrapper<Type> extends AbstractJavaSortedSet<Type> {
	
	final SortedSet<Type> collection;

	public ToJavaSortedSetWrapper(final SortedSet<Type> collection) {
		super();
		this.collection = collection;
	}

	@Override
	public Iterator<Type> iterator() {
		return this.collection.iterator();
	}

	@Override
	public int size() {
		return this.collection.size();
	}
	
	@Override
	public String toString() {
		return this.collection.toString();
	}
	
	@Override
	public boolean contains(final Object o) {
		return this.collection.contains(o);
	}
	
	@SuppressWarnings({ "rawtypes", "unchecked" })
	@Override
	public boolean containsAll(final java.util.Collection<?> c) {
		return this.collection.containsAll(new FromJavaCollectionWrapper(c));
	}
	
	@Override
	public Object[] toArray() {
		return this.collection.toArray();
	}
	
	@Override
	public <T> T[] toArray(final T[] a) {
		return this.collection.toArray(a);
	}

	@Override
	public Comparator<? super Type> comparator() {
		return this.collection.comparator();
	}

	@Override
	public java.util.SortedSet<Type> subSet(final Type fromElement, final Type toElement) {
		return this.collection.subSet(fromElement, toElement).javaCollection();
	}

	@Override
	public java.util.SortedSet<Type> headSet(final Type toElement) {
		return this.collection.headSet(toElement).javaCollection();
	}

	@Override
	public java.util.SortedSet<Type> tailSet(final Type fromElement) {
		return this.collection.tailSet(fromElement).javaCollection();
	}

	@Override
	public Type first() {
		return this.collection.first();
	}

	@Override
	public Type last() {
		return this.collection.last();
	}
	
}
