package de.lmu.ifi.pms.java.util.map.compatibility;

import de.lmu.ifi.pms.java.util.adaption.Adapter;
import de.lmu.ifi.pms.java.util.collection.Collection;
import de.lmu.ifi.pms.java.util.map.Map;
import de.lmu.ifi.pms.java.util.map.javaWrapper.FromJavaMapExtendibleWrapper;

public class HashMap<KeyType, ValueType> extends FromJavaMapExtendibleWrapper<KeyType, ValueType>{
	
	public HashMap() {
		this(16);
	}
	
	public HashMap(final int initialCapacity) {
		this(initialCapacity, 0.75f);
	}

	public HashMap(final int initialCapacity, final float loadFactor) {
		super(new java.util.HashMap<KeyType, ValueType>(initialCapacity, loadFactor));
	}

	public HashMap(final Map<KeyType, ValueType, ?> map){
		this(map.javaMap());
	}
    
	public HashMap(final java.util.Map<KeyType, ValueType> map){
		super(new java.util.HashMap<KeyType, ValueType>(map));
	}
	
	public HashMap(final Adapter<ValueType, KeyType> indexer, final Collection<ValueType> values){
		this();
		for(ValueType value: values){
			this.add(indexer.adapt(value), value);
		}
	}
	
}
