package de.lmu.ifi.pms.java.util.map.fixed;

import de.lmu.ifi.pms.java.lang.iteration.FixedIterator;
import de.lmu.ifi.pms.java.util.collection.fixed.set.AbstractFixedSet;
import de.lmu.ifi.pms.java.util.collection.set.Set;
import de.lmu.ifi.pms.java.util.map.javaWrapper.ToJavaMapWrapper;


public abstract class AbstractFixedMap<KeyType, ValueType, EntryType extends FixedEntry<KeyType, ValueType>> extends AbstractFixedSet<EntryType> implements FixedMap<KeyType, ValueType, EntryType> {
	
	@Override
	public java.util.AbstractMap<KeyType, ValueType> javaMap() {
		return new ToJavaMapWrapper<KeyType, ValueType>(this);
	}
	
	@SuppressWarnings("unchecked")
	@Deprecated
	@Override
	public final boolean containsKey(final Object key) {
		return this.has((KeyType)key);
	}
	
	
	
	@Deprecated
	@Override
	public final Set<KeyType> keySet() {
		return this.keys();
	}
	
	@Deprecated
	@Override
	public final AbstractFixedSet<EntryType> entrySet() {
		return this;
	}
		
	@Override
	public abstract FixedIterator<EntryType> iterator();
}
