package de.lmu.ifi.pms.java.util.stream.io;

import java.io.IOException;

import de.lmu.ifi.pms.java.util.collection.Collection;


public abstract class AbstractResourceCloseable<ResourceCollectionType extends Collection<? extends java.io.Closeable>> extends AbstractCloseableImpl{
	
	public AbstractResourceCloseable() {
		this(OpenState.OPEN);
	}

	public AbstractResourceCloseable(final OpenState state) {
		super(state, Synchronisation.Synchronized);
	}
	
	@Override
	public abstract Object closeLock();
	
	public abstract ResourceCollectionType resources();
	
	@Override
	protected final void openAction(){
		this.startOpen();
		for(final java.io.Closeable resource: this.resources()){
			try {
				((Openable)resource).open();
			} catch (final ClassCastException e) {

			}
		}
		this.endOpen();
	}
	
	protected void startOpen(){
		
	}
	
	protected void endOpen(){
		
	}
	
	@Override
	public final void closeAction(){
		this.startClose();
		for(final java.io.Closeable resource: this.resources()){
			try {
				resource.close();
			} catch (final IOException e) {

			}
		}
		this.endClose();
	}
	
	protected void startClose(){
		
	}
	
	protected void endClose(){
		
	}
	
}
