package de.lmu.ifi.pms.java.util.tupel;

public class Pair<Type, Type0 extends Type, Type1 extends Type> extends Single<Type, Type0>{

	private Type1 comp1;
	
	public Pair(final Type0 comp0, final Type1 comp1) {
		super(comp0);
		this.comp1 = comp1;
	}
	
	public final Type1 comp1(){
		return this.comp1;
	}
	
	public final void setComp1(final Type1 value){
		this.comp1 = value;
	}
	
	@Override
	public int componentCount() {
		return 2;
	}
	
	@Override
	public Type getComp(final int i) {
		if(i == 1){
			return this.comp1;
		}
		else{
			return super.getComp(i);
		}
	}
	
	@Override
	public Pair<Type, Type0, Type1> clone() {
		return new Pair<Type, Type0, Type1>(this.comp0(), this.comp1());
	}
	
}
